package ch.unibe.piccola.bridge;

import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkListener;
import ch.unibe.piccola.vm.Form;
import ch.unibe.piccola.vm.Service;

/**
 * Implements a generic <code>HyperlinkListener</code>.
 *
 * @author   Stefan Kneubuehl
 * @version  4.0 (Jun 09, 2003)
**/
public class GenericHyperlinkListener extends GenericListener
    implements HyperlinkListener
{

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    public GenericHyperlinkListener(Form handler)
    {
        m_hyperlinkUpdate = extractService(handler, "hyperlinkUpdate");
    }

    public void hyperlinkUpdate(HyperlinkEvent event)
    {
        m_hyperlinkUpdate.callback(this, event);
    }

    // ------------------------------------------------------------------------
    // private
    // ------------------------------------------------------------------------

    private final Service m_hyperlinkUpdate;

}
