package ch.unibe.piccola.bridge;

import java.awt.event.ItemListener;
import java.awt.event.ItemEvent;
import ch.unibe.piccola.vm.Form;
import ch.unibe.piccola.vm.Service;

/**
 * Implements a generic <code>ItemListener</code>.
 *
 * @author   Stefan Kneubuehl
 * @version  4.0 (Jun 09, 2003)
**/
public class GenericItemListener extends GenericListener
    implements ItemListener
{

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    public GenericItemListener(Form handler)
    {
        m_itemStateChanged = extractService(handler, "itemStateChanged");
    }

    public void itemStateChanged(ItemEvent event)
    {
        m_itemStateChanged.callback(this, event);
    }

    // ------------------------------------------------------------------------
    // private
    // ------------------------------------------------------------------------

    private final Service m_itemStateChanged;

}
