package ch.unibe.piccola.bridge;

import javax.swing.event.MenuEvent;
import javax.swing.event.MenuListener;
import ch.unibe.piccola.vm.Form;
import ch.unibe.piccola.vm.Service;

/**
 * Implements a generic <code>MenuListener</code>.
 *
 * @author   Stefan Kneubuehl
 * @version  4.0 (Jun 09, 2003)
**/
public class GenericMenuListener extends GenericListener
    implements MenuListener
{

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    public GenericMenuListener(Form handler)
    {
        m_menuCanceled = extractService(handler, "menuCanceled");
        m_menuDeselected = extractService(handler, "menuDeselected");
        m_menuSelected = extractService(handler, "menuSelected");
    }

    public void menuCanceled(MenuEvent event)
    {
        m_menuCanceled.callback(this, event);
    }

    public void menuDeselected(MenuEvent event)
    {
      	m_menuDeselected.callback(this, event);
    }

    public void menuSelected(MenuEvent event)
    {
      	m_menuSelected.callback(this, event);
    }

    // ------------------------------------------------------------------------
    // private
    // ------------------------------------------------------------------------

    private final Service m_menuCanceled;

    private final Service m_menuDeselected;

    private final Service m_menuSelected;

}
