package ch.unibe.piccola.bridge;

import java.awt.event.TextEvent;
import java.awt.event.TextListener;
import ch.unibe.piccola.vm.Form;
import ch.unibe.piccola.vm.Service;

/**
 * Implements a generic <code>TextListener</code>.
 *
 * @author   Stefan Kneubuehl
 * @version  4.0 (Jun 09, 2003)
**/
public class GenericTextListener extends GenericListener
    implements TextListener
{

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    public GenericTextListener(Form handler)
    {
        m_textValueChanged = extractService(handler, "textValueChanged");
    }

    public void textValueChanged(TextEvent event)
    {
        m_textValueChanged.callback(this, event);
    }

    // ------------------------------------------------------------------------
    // private
    // ------------------------------------------------------------------------

    private final Service m_textValueChanged;

}
