package ch.unibe.piccola.bytecode;

import ch.unibe.piccola.code.Arguments;
import ch.unibe.piccola.vm.Form;
import ch.unibe.piccola.vm.Service;

public class ImplVoidReturnInterfaceTest
			implements VoidReturnInterfaceTest{

	private Service m_voidAvoid;
	private Service m_voidAint;
	private Service m_voidAboolean;
	private Service m_voidAshort;
	private Service m_voidAbyte;
	private Service m_voidAlong;
	private Service m_voidAdouble;
	private Service m_voidAfloat;
	private Service m_voidAchar;
	private Service m_voidAObject;

    protected Service extractService(Form handler, String name)
    {
        return handler.project(name).service();
    }

	public ImplVoidReturnInterfaceTest(Form delegate) {
		m_voidAvoid = extractService(delegate, "voidAvoid");
		m_voidAint = extractService(delegate, "voidAint");
		m_voidAboolean = extractService(delegate, "voidAboolean");
		m_voidAshort = extractService(delegate, "voidAshort");
		m_voidAbyte = extractService(delegate, "voidAbyte");
		m_voidAlong = extractService(delegate, "voidAlong");
		m_voidAdouble = extractService(delegate, "voidAdouble");
		m_voidAfloat = extractService(delegate, "voidAfloat");
		m_voidAchar = extractService(delegate, "voidAchar");
		m_voidAObject = extractService(delegate, "voidAObject");
	}

	public void voidAvoid() {
		m_voidAvoid.callback(null);
	}

	public void voidAint(int i) {
		Arguments argList = new Arguments();
		argList.add(new Integer(i));
		m_voidAint.callback(argList);
	}

	public void voidAboolean(boolean b) {
		Arguments argList = new Arguments();
		argList.add(new Boolean(b));
		m_voidAboolean.callback(argList);
	}

	public void voidAshort(short s) {
		Arguments argList = new Arguments();
		argList.add(new Short(s));
		m_voidAshort.callback(argList);
	}

	public void voidAbyte(byte b) {
		Arguments argList = new Arguments();
		argList.add(new Byte(b));
		m_voidAbyte.callback(argList);
	}

	public void voidAlong(long l) {
		Arguments argList = new Arguments();
		argList.add(new Long(l));
		m_voidAlong.callback(argList);
	}

	public void voidAdouble(double d) {
		Arguments argList = new Arguments();
		argList.add(new Double(d));
		m_voidAdouble.callback(argList);
	}

	public void voidAfloat(float f) {
		Arguments argList = new Arguments();
		argList.add(new Float(f));
		m_voidAfloat.callback(argList);
	}

	public void voidAchar(char c) {
		Arguments argList = new Arguments();
		argList.add(new Character(c));
		m_voidAchar.callback(argList);
	}

	public void voidAObject(Object obj) {
		Arguments argList = new Arguments();
		argList.add(obj);
		m_voidAObject.callback(argList);
	}

}

