package ch.unibe.piccola.bytecode;

import org.apache.bcel.Constants;
import org.apache.bcel.generic.ClassGen;
import org.apache.bcel.generic.MethodGen;
import org.apache.bcel.generic.FieldGen;
import org.apache.bcel.generic.InstructionFactory;
import org.apache.bcel.generic.InstructionList;
import org.apache.bcel.generic.ConstantPoolGen;
import org.apache.bcel.generic.ObjectType;
import org.apache.bcel.generic.Type;

/**
 * @author  $Id: ServiceHandlerFactory.java,v 3.5 2003/01/10 13:46:28 kneubuhl Exp $
**/

public class ServiceHandlerFactory implements Constants, FactoryConstants {

	private InstructionList il;

	private ClassGen m_classGen;

	private InstructionFactory m_factory;

	public ServiceHandlerFactory(ClassGen cg) {
		m_classGen = cg;
		m_factory = new InstructionFactory(cg);
	}

	public ClassGen addServiceHandlerMethod(String className) {
		il = new InstructionList();
		ConstantPoolGen cp = m_classGen.getConstantPool();

		MethodGen mg = new MethodGen(ACC_PROTECTED,
								     m_IFormObjectType,
									 new Type[] {Type.STRING},
									 null, "getService", className, il, cp);
		il = generateServiceHandlerMethodBody(il, className);

		mg.setMaxStack();
		mg.setMaxLocals();
		m_classGen.addMethod(mg.getMethod());

		il.dispose();

		return m_classGen;
	}

	private InstructionList generateServiceHandlerMethodBody(InstructionList il, String className) {
		il.append(m_factory.createThis());
		il.append(m_factory.createFieldAccess(className, "m_delegate",
					    						m_IFormObjectType, Constants.GETFIELD));
		il.append(m_factory.createLoad(Type.STRING, 1));
		il.append(m_factory.createInvoke(FORM_CLASS, "project",
				       m_IFormObjectType, new Type[] {new ObjectType("java.lang.String")},
				       Constants.INVOKEVIRTUAL));
		il.append(m_factory.createReturn(Type.OBJECT));
		return il;
	}

}
