package ch.unibe.piccola.code;

import ch.unibe.piccola.source.SourceRef;

/**
 * Represents a code frame for Piccola code.
 *
 * @author   Stefan Kneubuehl
 * @version  3.4c (Oct 16, 2002)
**/
public class CodeFrame {

    // --------------------------------------------------------------------
    // public
    // --------------------------------------------------------------------

    /**
     * Returns the next opcode to be executed.
     *
     * @return the next opcode to be executed.
    **/
    public final OpCode next()
    {
        return m_code.get(m_current++);
    }

    public final SourceRef getSourceRef()
    {
        return m_code.getSourceRef();
    }

    // --------------------------------------------------------------------
    // default
    // --------------------------------------------------------------------

    CodeFrame(Code code)
    {
        m_code = code;
        m_current = 0;
    }

    // --------------------------------------------------------------------
    // private
    // --------------------------------------------------------------------

    private final Code m_code;

    private int m_current;

}