package ch.unibe.piccola.code;

import ch.unibe.piccola.source.SourceRef;

/**
 * @author   Stefan Kneubuehl
 * @version  3.4c (Aug 08, 2002)
**/
class OpHide extends OpCode
{

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    public final boolean equals(Object object)
    {
        if (!super.equals(object)) {
            return false;
        }
        return m_label.equals(((OpHide) object).m_label);
    }

    public final void execute(IVM vm)
    {
        vm.opHide(m_label);
    }

    public final String toString()
    {
        return "OpHide(" + m_label + ")";
    }

    // ------------------------------------------------------------------------
    // default
    // ------------------------------------------------------------------------

    OpHide(SourceRef sourceRef, String label)
    {
        super(sourceRef);
        m_label = label;
    }

    // ------------------------------------------------------------------------
    // private
    // ------------------------------------------------------------------------

    private final String m_label;

}