package ch.unibe.piccola.parser;

import java.io.IOException;
import ch.unibe.piccola.parser.javacc.ParserImpl;
import ch.unibe.piccola.parser.javacc.ParseException;
import ch.unibe.piccola.parser.javacc.Token;
import ch.unibe.piccola.syntax.Node;
import ch.unibe.piccola.source.SourceCode;
import ch.unibe.piccola.source.SourceRef;

/**
 * @author    Stefan Kneubuehl
 * @version   3.4c (Jul 19, 2002)
**/
class JavaCCParser extends Parser
{

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    public JavaCCParser()
    {
        m_parser = null;
    }

    public Node parse(SourceCode sourceCode)
        throws IOException, ParserException
    {
        try {
            // TODO: Remove line below when JCCParser's ReInit method is fixed.
            m_parser = null;
            if (null == m_parser) {
                m_parser = new ParserImpl(sourceCode.newReader());
            }
            else {
                m_parser.ReInit(sourceCode.newReader());
            }
            m_parser.setSource(sourceCode);
            return m_parser.script();
        }
        catch (ParseException ex) {
            Token t = ex.currentToken.next;
            ex.sourceRef = new SourceRef(sourceCode,
                t.m_beginPos, t.beginLine, t.beginColumn,
                t.getEndPos(), t.beginLine, t.beginColumn);
            throw new ParserException(ex);
        }

    }

    public String toString()
    {
        return "JPiccola JavaCC Parser 3.4c (Oct 03, 2002)";
    }

    // ------------------------------------------------------------------------
    // private
    // ------------------------------------------------------------------------

    private ParserImpl m_parser;

}