package ch.unibe.piccola.parser;

/**
 * Parser factory in order to support different parser implementations.
 *
 * @author   Stefan Kneubuehl
 * @version  3.4c (Dec 09, 2002)
**/
public class ParserFactory
{

    // ------------------------------------------------------------------------
    // public static
    // ------------------------------------------------------------------------

    /**
     * The singleton instance of ParserFactory
    **/
    public static ParserFactory INSTANCE = new ParserFactory();

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    /**
     * Returns a new JavaCC parser.
     *
     * @return a new JavaCC parser.
    **/
    public Parser newJavaCCParser()
    {
        return new JavaCCParser();
    }

    // ------------------------------------------------------------------------
    // private
    // ------------------------------------------------------------------------

    private ParserFactory()
    {
    }

}