package ch.unibe.piccola.parser.javacc;

import java.util.ArrayList;
import java.util.Iterator;
import ch.unibe.piccola.syntax.Node;
import ch.unibe.piccola.source.SourceRef;

/**
 * @author    Stefan Kneubuehl
 * @version   3.4c (Jul 14, 2002)
**/
class NamedAbstractionStatement extends Statement
{

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    public NamedAbstractionStatement(Token def, ArrayList labels,
                                     ArrayList params, Statement stmt)
    {
        super(stmt.getNode());
        m_def = def;
        m_labels = labels;
        m_params = params;
    }

    public Node extend(Node s)
    {
        return makeNamedAbstraction(s);
    }

    public Node getNode()
    {
        return makeNamedAbstraction(null);
    }

    // ------------------------------------------------------------------------
    // private
    // ------------------------------------------------------------------------

    private Token m_def;

    private ArrayList m_labels;

    private ArrayList m_params;

    private String[] tokensToStrings(ArrayList tokens)
    {
        String[] strings = new String[tokens.size()];
        Iterator e = tokens.iterator();
        int i = 0;
        while (e.hasNext()) {
            Token token = (Token) e.next();
            strings[i] = null == token ? "" : token.toString();
            ++i;
        }
        return strings;
    }

    private Node makeNamedAbstraction(Node s)
    {
        if (null == s) {
            s = sf.newEmpty(super.getNode().getSourceRef());
        }
        Token begin = null == m_def ? (Token) m_labels.get(0) : m_def;
        SourceRef sc = new SourceRef(begin.m_beginPos, begin.beginLine,
            begin.beginColumn, s.getSourceRef());
        String[] labels = tokensToStrings(m_labels);
        String[] params = tokensToStrings(m_params);
        return sf.newNamedAbstraction(sc, super.getNode(), s, labels,
                params, null != m_def);
    }

}