package ch.unibe.piccola.parser.javacc;

import ch.unibe.piccola.syntax.Node;
import ch.unibe.piccola.source.SourceRef;

/**
 * @author    Stefan Kneubuehl
 * @version   3.4c (Jul 14, 2001)
**/
class QuoteStatement extends Statement
{

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    public QuoteStatement(Token quote, Statement stmt)
    {
        super(stmt.getNode());
        m_quote = quote;
    }

    public Node extend(Node s)
    {
        return makeQuote(s);
    }

    public Node getNode()
    {
        return makeQuote(null);
    }

    // ------------------------------------------------------------------------
    // private
    // ------------------------------------------------------------------------

    private Token m_quote;

    private Node makeQuote(Node s)
    {
        if (null == s) {
            s = sf.newEmpty(super.getNode().getSourceRef());
        }
        SourceRef sc = new SourceRef(m_quote.m_beginPos, m_quote.beginLine,
            m_quote.beginColumn, s.getSourceRef());
        return sf.newQuote(sc, super.getNode(), s);
    }

}