package ch.unibe.piccola.parser.javacc;

import ch.unibe.piccola.syntax.Node;
import ch.unibe.piccola.syntax.SyntaxFactory;
import ch.unibe.piccola.source.SourceRef;

/**
 * @author   Stefan Kneubuehl
 * @version  3.4c (Jul 14, 2002)
**/
class Statement
{

    // ------------------------------------------------------------------------
    // protected static
    // ------------------------------------------------------------------------

    protected static SyntaxFactory sf = SyntaxFactory.INSTANCE;

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    public Statement()
    {
        this(null);
    }

    public Statement(Node node)
    {
        m_node = node;
    }

    public Node extend(Node s)
    {
        SourceRef sc = new SourceRef(m_node.getSourceRef(), s.getSourceRef());
        return sf.newExtension(sc, m_node, s);
    }

    public Node getNode()
    {
        return m_node;
    }

    // ------------------------------------------------------------------------
    // private
    // ------------------------------------------------------------------------

    private Node m_node;

}