package ch.unibe.piccola.source;

import java.io.Reader;
import java.io.StringReader;

/**
 * This class represents Piccola source code located in a Java String.
 *
 * @author   Stefan Kneubuehl
 * @version  3.4c (Oct 17, 2002)
**/
public class StringSourceCode extends SourceCode
{

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    /**
     * Creates a new StringSourceCode object.
     *
     * @param source a string containing Piccola source code.
    **/
    public StringSourceCode(String source)
    {
        m_source = source;
    }

    /**
     * Creates a new Reader reading the source code.
     *
     * @return a new Reader reading the source code.
    **/
    public final Reader newReader()
    {
        return new StringReader(m_source);
    }

    /**
     * Returns a string representation of this source code.
     *
     * @return a string representation of this source code.
    **/
    public final String toString()
    {
        return m_source;
    }

    // ------------------------------------------------------------------------
    // private
    // ------------------------------------------------------------------------

    private final String m_source;

}