package ch.unibe.piccola.syntax;

import ch.unibe.piccola.source.SourceRef;

/**
 * Represents a sandbox syntax node.
 *
 * @author   Stefan Kneubuehl
 * @version  3.4c (Nov 14, 2002)
**/
public class Sandbox extends TwoChildrenNode
{

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    /**
     * Accepts a node visitor.
     *
     * @param  visitor the node visitor to be accepted.
     *
     * @return   the result of the visitor's visitSandbox method.
    **/
    public Object accept(NodeVisitor visitor)
    {
        return visitor.visitSandbox(this);
    }

    /**
     * Returns a debug string representation of this sandbox node.
     *
     * @return a debug string representation of this sandbox node.
    **/
    public String toString()
    {
        return "Sandbox" + super.toString();
    }

    // ------------------------------------------------------------------------
    // default
    // ------------------------------------------------------------------------

    Sandbox(SourceRef sourceRef, Node leftChild, Node rightChild)
    {
        super(sourceRef, leftChild, rightChild);
    }

    // ------------------------------------------------------------------------
    // protected
    // ------------------------------------------------------------------------

    protected Node newInstance(Node leftChild, Node rightChild)
    {
        return new Sandbox(getSourceRef(), leftChild, rightChild);
    }

}