package ch.unibe.piccola.syntax;

/**
 * Piccola syntax constants.
 *
 * @author   Stefan Kneubuehl
 * @version  3.6c (May 11, 2003)
**/
public interface SyntaxConsts
{

    /**
     * Standard Piccola label "add" (collections).
    **/
    public static final String S_ADD = "add";

    /**
     * Standard Piccola label "arg" (argument passing).
    **/
    public static final String S_ARG = "arg";

    /**
     * Standard Piccola label "caller" (stack trace).
    **/
    public static final String S_CALLER = "caller";

    /**
     * Piccola keyword "def".
    **/
    public static final String S_DEF = "def";

    /**
     * Standard Piccola label part "default" (default operators).
    **/
    public static final String S_DEFAULT = "default";

    /**
     * Standard Piccola label "DefaultOp"  (default operators).
    **/
    public static final String S_DEFAULT_OP = "DefaultOp";

    /**
     * Standard Piccola label "dynamic" (dynamic context).
    **/
    public static final String S_DYNAMIC = "dynamic";

    /**
     * Standard String representation of the empty form "()".
    **/
    public static final String S_EMPTY = "()";

    /**
     * Standard Piccola label "_==_" (equality operator).
    **/
    public static final String S_EQUAL_OP = "_==_";

    /**
     * Standard Piccola label "false" (boolean value).
    **/
    public static final String S_FALSE = "false";

    /**
     * Standard Piccola label "hash" (hash code).
    **/
    public static final String S_HASH = "hash";

    /**
     * Standard Piccola label "if" (control service).
    **/
    public static final String S_IF = "if";

    /**
     * Standard Piccola label "L" (operator simplification).
    **/
    public static final String S_L_LABEL = "L";

    /**
     * Standard Piccola label "main" (script execution entry point).
    **/
    public static final String S_MAIN = "main";

    /**
     * Standard Piccola label "meta" (built-in service).
    **/
    public static final String S_META = "meta";

    /**
     * Standard Piccola label "new" (Java constructor name).
    **/
    public static final String S_NEW = "new";

    /**
     * Standard Piccola label "newArray" (Java array constructor name).
    **/
    public static final String S_NEWARRAY = "newArray";

    /**
     * Standard Piccola label "peer" (Java bridge).
    **/
    public static final String S_PEER = "peer";

    /**
     * Standard Piccola label "R" (operator simplification).
    **/
    public static final String S_R_LABEL = "R";

    /**
     * Standard Piccola label "receive" (channel service).
    **/
    public static final String S_RECEIVE = "receive";

    /**
     * Standard Piccola label "send"  (channel service).
    **/
    public static final String S_SEND = "send";

    /**
     * Standard Piccola label "set" (variable cell service).
    **/
    public static final String S_SET = "set";

    /**
     * Standard Piccola label "src"  (stack trace).
    **/
    public static final String S_SRC = "src";

    /**
     * Standard Piccola label "getStackTrace"  (stack trace).
    **/
    public static final String S_STACK_TRACE = "getStackTrace";

    /**
     * Standard Piccola label "$_" (string operator).
    **/
    public static final String S_STRING_OP = "$_";

    /**
     * Standard Piccola label "true" (boolean value).
    **/
    public static final String S_TRUE = "true";

    /**
     * Standard Piccola label "val" (bridge).
    **/
    public static final String S_VAL = "val";

}

