package ch.unibe.piccola.type;

/**
 * Represents the context type variable 'R'.
 *
 * @author    Stefan Kneubuehl
 * @version   3.4c (Jan 03, 2003)
**/
public class TypeVariableNormal extends TypeVariable
{

    // ------------------------------------------------------------------------
    // private static
    // ------------------------------------------------------------------------

    private static char m_counter = 'A';

    public static void reset()
    {
        m_counter = 'A';
    }

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    public String toString()
    {
        return m_name;
    }

    public Type reverse()
    {
        return m_reverse;
    }

    // ------------------------------------------------------------------------
    // default
    // ------------------------------------------------------------------------

    TypeVariableNormal()
    {
        m_name = "" + m_counter + "+";
        m_reverse = new TypeVariableNormal(this);
        ++m_counter;
    }

    // ------------------------------------------------------------------------
    // private
    // ------------------------------------------------------------------------

    private String m_name;

    private final TypeVariableNormal m_reverse;

    private TypeVariableNormal(TypeVariableNormal positive)
    {
        m_name = "" + m_counter + "-";
        m_reverse = positive;
    }

}