package ch.unibe.piccola.vm;

import ch.unibe.piccola.source.SourceRef;

/**
 * @author   Stefan Kneubuehl
 * @version  3.4c (Sep 21, 2002)
**/
public class AgentException extends RuntimeException
{

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    public AgentException(Throwable exception)
    {
        this(null, exception.toString());
    }

    public AgentException(String message)
    {
        this(null, message);
    }

    public AgentException(SourceRef sourceRef, String message)
    {
        super(message);
        m_dynamic = null;
        m_sourceRef = sourceRef;
    }

    public Form getDynamic()
    {
        return m_dynamic;
    }

    public String toString()
    {
        StringBuffer msg = new StringBuffer();
        msg.append("----------------------------------------");
        msg.append("---------------------------------------\n");
        msg.append("Piccola Exception: " + getMessage() + "\n");
        if (null != m_sourceRef) {
            msg.append("at " + m_sourceRef + "\n\n");
        }
        msg.append("----------------------------------------");
        msg.append("---------------------------------------\n");
        return msg.toString();
    }

    public final void setDynamic(Form value)
    {
        if (null == m_dynamic) {
            m_dynamic = value;
        }
    }

    public final void setSourceRef(SourceRef value)
    {
        if (null == m_sourceRef) {
            m_sourceRef = value;
        }
    }

    public final SourceRef getSourceRef()
    {
        return m_sourceRef;
    }

    // ------------------------------------------------------------------------
    // private
    // ------------------------------------------------------------------------

    private Form m_dynamic;

    private SourceRef m_sourceRef;

}