package ch.unibe.piccola.vm;

import java.io.IOException;
import ch.unibe.piccola.code.Arguments;
import ch.unibe.piccola.code.Code;
import ch.unibe.piccola.source.SourceRef;
import ch.unibe.piccola.type.ContractualType;
import ch.unibe.piccola.syntax.Syntax;

/**
 * @author   Stefan Kneubuehl
 * @version  3.6c (Apr 23, 2003)
**/
public class ServiceForm extends DefaultForm
{

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    public boolean equals(Object object)
    {
        return false;
    }

    public boolean exists(String label)
    {
        return false;
    }

    public Service service()
    {
        return m_service;
    }

    public boolean isService()
    {
        return true;
    }

    public boolean runtimeEquals(Form form)
    {
        return false;
    }

    public int runtimeHashCode()
    {
        return m_service.hashCode();
    }

    /**
     * Returns a strings representation of this form. The string representation
     * of a service is the service's source code, if available. When not
     * available, the string <code>"(service)"</code> is returned.
     *
     * @return the string representation of this form.
    **/
    public final String runtimeToString()
    {
        return "[service]";
    }

    public String toString()
    {
        return runtimeToString();
    }

//    public ContractualType type()
//    {
//        return ContractualType.typeOf(m_code, m_context);
//    }

    // ------------------------------------------------------------------------
    // default
    // ------------------------------------------------------------------------

    ServiceForm(FormFactory factory, Service service)
    {
        super(factory);
        m_service = service;
    }

    // ------------------------------------------------------------------------
    // private
    // ------------------------------------------------------------------------

    private final Service m_service;

}

